IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'ICL01')
	DROP DATABASE [ICL01]
GO

CREATE DATABASE [ICL01]  ON (NAME = N'ICl01_Data', FILENAME = N'D:\Databases\ICL01.mdf' , SIZE = 278, FILEGROWTH = 10%) LOG ON (NAME = N'ICl01_Log', FILENAME = N'D:\Databases\ICL01_log.ldf' , SIZE = 505, FILEGROWTH = 10%)
 COLLATE SQL_Latin1_General_CP1_CI_AS
GO

exec sp_dboption N'ICL01', N'autoclose', N'false'
GO

exec sp_dboption N'ICL01', N'bulkcopy', N'false'
GO

exec sp_dboption N'ICL01', N'trunc. log', N'false'
GO

exec sp_dboption N'ICL01', N'torn page detection', N'true'
GO

exec sp_dboption N'ICL01', N'read only', N'false'
GO

exec sp_dboption N'ICL01', N'dbo use', N'false'
GO

exec sp_dboption N'ICL01', N'single', N'false'
GO

exec sp_dboption N'ICL01', N'autoshrink', N'false'
GO

exec sp_dboption N'ICL01', N'ANSI null default', N'false'
GO

exec sp_dboption N'ICL01', N'recursive triggers', N'false'
GO

exec sp_dboption N'ICL01', N'ANSI nulls', N'false'
GO

exec sp_dboption N'ICL01', N'concat null yields null', N'false'
GO

exec sp_dboption N'ICL01', N'cursor close on commit', N'false'
GO

exec sp_dboption N'ICL01', N'default to local cursor', N'false'
GO

exec sp_dboption N'ICL01', N'quoted identifier', N'false'
GO

exec sp_dboption N'ICL01', N'ANSI warnings', N'false'
GO

exec sp_dboption N'ICL01', N'auto create statistics', N'true'
GO

exec sp_dboption N'ICL01', N'auto update statistics', N'true'
GO

use [ICL01]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblPortfolio_tblFundGame]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblPortfolio] DROP CONSTRAINT FK_tblPortfolio_tblFundGame
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblSharePick_tblPortfolio]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblSharePick] DROP CONSTRAINT FK_tblSharePick_tblPortfolio
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblSharePick_tblShare]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblSharePick] DROP CONSTRAINT FK_tblSharePick_tblShare
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblPortfolio_tblUser]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblPortfolio] DROP CONSTRAINT FK_tblPortfolio_tblUser
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblFundGame_tlkpFundGameType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblFundGame] DROP CONSTRAINT FK_tblFundGame_tlkpFundGameType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblPortfolio_tlkpPortfolioSelectionType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblPortfolio] DROP CONSTRAINT FK_tblPortfolio_tlkpPortfolioSelectionType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblPortfolio_tlkpRegistrationType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblPortfolio] DROP CONSTRAINT FK_tblPortfolio_tlkpRegistrationType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblUser_tlkpSex]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblUser] DROP CONSTRAINT FK_tblUser_tlkpSex
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblSharePick_tlkpSharePickType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblSharePick] DROP CONSTRAINT FK_tblSharePick_tlkpSharePickType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblShare_tlkpShareSector]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblShare] DROP CONSTRAINT FK_tblShare_tlkpShareSector
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblFundGame_tlkpStockExchange]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblFundGame] DROP CONSTRAINT FK_tblFundGame_tlkpStockExchange
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tblUser_tlkpStockExchange]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tblUser] DROP CONSTRAINT FK_tblUser_tlkpStockExchange
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tlkpStockExchange_tlkplCountry]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tlkpStockExchange] DROP CONSTRAINT FK_tlkpStockExchange_tlkplCountry
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_tbllMessage_tlkplMessageType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[tbllMessage] DROP CONSTRAINT FK_tbllMessage_tlkplMessageType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgFundGameGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgFundGameGetAll]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgFundGameGetById]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgFundGameGetById]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPortfolioById]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPortfolioById]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPortfolioByUserFundGame]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPortfolioByUserFundGame]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPortfolioGetById]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPortfolioGetById]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPortfolioListingByUser]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPortfolioListingByUser]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPortfolioSummaryByUserFund]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPortfolioSummaryByUserFund]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgPrimaryStockExchangeByUser]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgPrimaryStockExchangeByUser]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgSharePicksByPortfolio]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgSharePicksByPortfolio]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgStockExchangeGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgStockExchangeGetAll]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgUserGetById]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgUserGetById]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spgUsersPerformanceReport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spgUsersPerformanceReport]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spglaLogin]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spglaLogin]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spglaLoginDetails]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spglaLoginDetails]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiESignalDownloadHistory]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiESignalDownloadHistory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiESignalDownloadHistory2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiESignalDownloadHistory2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiESignalDownloadQuote]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiESignalDownloadQuote]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiESignalDownloadTimeSales]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiESignalDownloadTimeSales]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiPortfolio]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiPortfolio]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spiUser]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spiUser]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[splCounterIdByRef]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[splCounterIdByRef]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[splgCountryGetAll]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[splgCountryGetAll]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spliCounter]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spliCounter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spliMessage]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spliMessage]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spluCounterByRef]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spluCounterByRef]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spuPortfolio]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spuPortfolio]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[spuUser]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[spuUser]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblESignalDownloadHistory]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblESignalDownloadHistory]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblESignalDownloadHistory2]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblESignalDownloadHistory2]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblESignalDownloadQuote]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblESignalDownloadQuote]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblESignalDownloadTimeSales]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblESignalDownloadTimeSales]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblESignalStock]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblESignalStock]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblFundGame]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblFundGame]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblPortfolio]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblPortfolio]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblShare]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblShare]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblSharePick]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblSharePick]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tblUser]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tblUser]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbllCounter]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbllCounter]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tbllMessage]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tbllMessage]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpFundGameType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpFundGameType]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpPortfolioSelectionType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpPortfolioSelectionType]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpRegistrationType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpRegistrationType]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpSex]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpSex]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpSharePickType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpSharePickType]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpShareSector]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpShareSector]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkpStockExchange]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkpStockExchange]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkplCountry]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkplCountry]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[tlkplMessageType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[tlkplMessageType]
GO

if not exists (select * from master.dbo.syslogins where loginname = N'Duwamish7_login')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'Duwamish7vb', @loginlang = N'us_english'
	if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'Duwamish7_login', null, @logindb, @loginlang
END
GO

if not exists (select * from master.dbo.syslogins where loginname = N'GOLDSWOR-7105EY\ASPNET')
	exec sp_grantlogin N'GOLDSWOR-7105EY\ASPNET'
	exec sp_defaultdb N'GOLDSWOR-7105EY\ASPNET', N'master'
	exec sp_defaultlanguage N'GOLDSWOR-7105EY\ASPNET', N'us_english'
GO

if not exists (select * from master.dbo.syslogins where loginname = N'Sterling')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'master', @loginlang = N'us_english'
	if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'Sterling', null, @logindb, @loginlang
END
GO

if not exists (select * from master.dbo.syslogins where loginname = N'Test')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'pubs', @loginlang = N'us_english'
	if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'Test', null, @logindb, @loginlang
END
GO

if not exists (select * from master.dbo.syslogins where loginname = N'thumper')
BEGIN
	declare @logindb nvarchar(132), @loginlang nvarchar(132) select @logindb = N'Mod01', @loginlang = N'us_english'
	if @logindb is null or not exists (select * from master.dbo.sysdatabases where name = @logindb)
		select @logindb = N'master'
	if @loginlang is null or (not exists (select * from master.dbo.syslanguages where name = @loginlang) and @loginlang <> N'us_english')
		select @loginlang = @@language
	exec sp_addlogin N'thumper', null, @logindb, @loginlang
END
GO

exec sp_addsrvrolemember N'Test', sysadmin
GO

exec sp_addsrvrolemember N'Test', securityadmin
GO

exec sp_addsrvrolemember N'Test', serveradmin
GO

exec sp_addsrvrolemember N'Test', setupadmin
GO

exec sp_addsrvrolemember N'Test', processadmin
GO

exec sp_addsrvrolemember N'Test', diskadmin
GO

exec sp_addsrvrolemember N'Test', dbcreator
GO

exec sp_addsrvrolemember N'Test', bulkadmin
GO

if not exists (select * from dbo.sysusers where name = N'ASPNET' and uid < 16382)
	EXEC sp_grantdbaccess N'ASPNET'
GO

exec sp_addrolemember N'db_accessadmin', N'ASPNET'
GO

exec sp_addrolemember N'db_backupoperator', N'ASPNET'
GO

exec sp_addrolemember N'db_datareader', N'ASPNET'
GO

exec sp_addrolemember N'db_datawriter', N'ASPNET'
GO

exec sp_addrolemember N'db_ddladmin', N'ASPNET'
GO

exec sp_addrolemember N'db_denydatareader', N'ASPNET'
GO

exec sp_addrolemember N'db_denydatawriter', N'ASPNET'
GO

exec sp_addrolemember N'db_owner', N'ASPNET'
GO

exec sp_addrolemember N'db_securityadmin', N'ASPNET'
GO

CREATE TABLE [dbo].[tblESignalDownloadHistory] (
	[fldESignalStockName] [nvarchar] (8) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddOpen] [float] NULL ,
	[flddHigh] [float] NULL ,
	[flddLow] [float] NULL ,
	[flddClose] [float] NULL ,
	[flddVolume] [float] NULL ,
	[flddtTime] [datetime] NULL ,
	[fldbtbfFlags] [bit] NULL ,
	[flddOI] [float] NULL ,
	[flddTickBid] [float] NULL ,
	[flddTickAsk] [float] NULL ,
	[flddTickTrade] [float] NULL ,
	[fldDateRecorded] [datetime] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblESignalDownloadHistory2] (
	[fldESignalStockName] [nvarchar] (8) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddClose] [float] NULL ,
	[flddtTime] [datetime] NULL ,
	[fldDateRecorded] [datetime] NULL ,
	[fldiId] [int] IDENTITY (1, 1) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblESignalDownloadQuote] (
	[fldsESignalStockName] [nvarchar] (6) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddtDateRecorded] [smalldatetime] NOT NULL ,
	[flddAsk] [float] NULL ,
	[flddBid] [float] NULL ,
	[flddLast] [float] NULL ,
	[fldilAskSize] [int] NULL ,
	[fldilBidSize] [int] NULL ,
	[fldilLastSize] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblESignalDownloadTimeSales] (
	[fldESignalStockName] [nvarchar] (6) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddtDateRecorded] [smalldatetime] NULL ,
	[flddPrice] [float] NULL ,
	[flddtTime] [datetime] NULL ,
	[fldlSize] [int] NULL ,
	[fldlFlags] [int] NULL ,
	[fldsExchange] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblESignalStock] (
	[fldName] [nvarchar] (6) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblFundGame] (
	[fldsName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsFundGameTypeName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsDescription] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldiFrequency] [int] NOT NULL ,
	[flddInitialCashValue] [float] NOT NULL ,
	[fldsStockExchangeName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldiDisplayOrder] [int] NOT NULL ,
	[fldiFundEntrantsDEV] [int] NOT NULL ,
	[fldbDisableStandingDisplay] [int] NOT NULL ,
	[fldiId] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblPortfolio] (
	[fldiId] [int] NOT NULL ,
	[fldiFundGameId] [int] NOT NULL ,
	[fldiUserId] [int] NOT NULL ,
	[fldsPortfolioSelectionTypeName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldiRankingDEV] [int] NOT NULL ,
	[flddPortfolioValueDEV] [float] NOT NULL ,
	[fldsRegistrationTypeName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddtStartDate] [smalldatetime] NOT NULL ,
	[fldbPay] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblShare] (
	[fldsName] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsSectorName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddCurrentPriceDEV] [float] NOT NULL ,
	[fldsDescription] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblSharePick] (
	[fldsShareName] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldiPortfolioId] [int] NOT NULL ,
	[flddQuantity] [int] NOT NULL ,
	[fldsSharePickTypeName] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldiLine] [int] NOT NULL ,
	[flddTargetPrice] [float] NOT NULL ,
	[flddtTargetDate] [smalldatetime] NOT NULL ,
	[fldsTargetNotes] [nvarchar] (1000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[flddEmailAlertValue] [float] NOT NULL ,
	[flddInitialPriceDEV] [float] NOT NULL ,
	[flddCommissionDEV] [float] NOT NULL ,
	[flddCashSurplusDEV] [float] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tblUser] (
	[fldiId] [int] NOT NULL ,
	[fldsTitle] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsSexName] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsFirstName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsLastName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsAddress] [nvarchar] (200) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsPostCode] [nvarchar] (8) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldslCountryName] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsTel] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsEMail] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsPassword] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsPrimaryStockExchangeName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldbNotify] [int] NOT NULL ,
	[fldbSAActive] [int] NOT NULL ,
	[fldbSATest] [int] NOT NULL ,
	[fldsSAWhiteLabelVersion] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbllCounter] (
	[fldRef] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldId] [int] NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tbllMessage] (
	[fldUser] [nvarchar] (255) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldErrDescription] [nvarchar] (4000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldContext] [nvarchar] (4000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldlMessageTypeId] [smallint] NOT NULL ,
	[fldCreateDate] [smalldatetime] NOT NULL ,
	[fldStack] [nvarchar] (4000) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldBrowserDetails] [ntext] COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldTransactionMessage] [nvarchar] (100) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpFundGameType] (
	[fldsName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpPortfolioSelectionType] (
	[fldName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpRegistrationType] (
	[fldsName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpSex] (
	[fldName] [nvarchar] (1) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpSharePickType] (
	[fldsName] [nvarchar] (10) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpShareSector] (
	[fldsName] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkpStockExchange] (
	[fldsName] [nvarchar] (20) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsDescription] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldslCountryName] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkplCountry] (
	[fldsName] [nvarchar] (3) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL ,
	[fldsDescription] [nvarchar] (30) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[tlkplMessageType] (
	[fldId] [smallint] NOT NULL ,
	[fldDescription] [nvarchar] (50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblESignalStock] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblESignalStock] PRIMARY KEY  CLUSTERED 
	(
		[fldName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblFundGame] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblFundGame] PRIMARY KEY  CLUSTERED 
	(
		[fldiId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblPortfolio] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblPortfolio] PRIMARY KEY  CLUSTERED 
	(
		[fldiId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblShare] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblShare] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblUser] WITH NOCHECK ADD 
	CONSTRAINT [PK_tblUser] PRIMARY KEY  CLUSTERED 
	(
		[fldiId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpFundGameType] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpGameFundType] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpPortfolioSelectionType] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpPortfolioSelectionType] PRIMARY KEY  CLUSTERED 
	(
		[fldName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpRegistrationType] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpRegistrationType] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpSex] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpSex] PRIMARY KEY  CLUSTERED 
	(
		[fldName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpSharePickType] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpSharePickType] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpShareSector] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpShareSector] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkpStockExchange] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkpStockExchange] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkplCountry] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkplCountry] PRIMARY KEY  CLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tlkplMessageType] WITH NOCHECK ADD 
	CONSTRAINT [PK_tlkplMessageType] PRIMARY KEY  CLUSTERED 
	(
		[fldId]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblESignalDownloadHistory] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblESignalDownloadHistory_fldDateRecorded] DEFAULT (getdate()) FOR [fldDateRecorded]
GO

 CREATE  INDEX [IX_tblEsignalDownloadHistory] ON [dbo].[tblESignalDownloadHistory]([fldESignalStockName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblESignalDownloadHistory2] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblESignalDownloadHistory2_fldDateRecorded] DEFAULT (getdate()) FOR [fldDateRecorded]
GO

ALTER TABLE [dbo].[tblESignalDownloadQuote] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblESignalDownloadQuote_flddtDateRecorded] DEFAULT (getdate()) FOR [flddtDateRecorded]
GO

ALTER TABLE [dbo].[tblESignalDownloadTimeSales] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblESignalDownloadTimeSales_fldDateRecorded] DEFAULT (getdate()) FOR [flddtDateRecorded]
GO

ALTER TABLE [dbo].[tblFundGame] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblFundGame_fldiFrequency] DEFAULT (1) FOR [fldiFrequency],
	CONSTRAINT [DF_tblFundGame_flddInitialCashValue] DEFAULT (0) FOR [flddInitialCashValue],
	CONSTRAINT [DF_tblFundGame_fldiFundEntrantsDEV] DEFAULT ((-1)) FOR [fldiFundEntrantsDEV],
	CONSTRAINT [DF_tblFundGame_fldbDisableRankingDisplay] DEFAULT (0) FOR [fldbDisableStandingDisplay],
	CONSTRAINT [IX_tblFundGame_2] UNIQUE  NONCLUSTERED 
	(
		[fldsName]
	)  ON [PRIMARY] ,
	CONSTRAINT [IX_tblFundGame_3] UNIQUE  NONCLUSTERED 
	(
		[fldiDisplayOrder]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_tblFundGame] ON [dbo].[tblFundGame]([fldsFundGameTypeName]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblFundGame_1] ON [dbo].[tblFundGame]([fldsStockExchangeName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblPortfolio] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblPortfolio_fldiRanking] DEFAULT ((-1)) FOR [fldiRankingDEV],
	CONSTRAINT [DF_tblPortfolio_flddPortfolioValueDEV] DEFAULT (0) FOR [flddPortfolioValueDEV],
	CONSTRAINT [DF_tblPortfolio_flddtStartDate] DEFAULT (getdate()) FOR [flddtStartDate],
	CONSTRAINT [idxFundGameUser] UNIQUE  NONCLUSTERED 
	(
		[fldiFundGameId],
		[fldiUserId]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_tblPortfolio] ON [dbo].[tblPortfolio]([fldsPortfolioSelectionTypeName]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblPortfolio_1] ON [dbo].[tblPortfolio]([fldiFundGameId]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblPortfolio_2] ON [dbo].[tblPortfolio]([fldsRegistrationTypeName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblShare] WITH NOCHECK ADD 
	CONSTRAINT [DF_tblShare_flddCurrentPrice] DEFAULT ((-1)) FOR [flddCurrentPriceDEV]
GO

 CREATE  INDEX [IX_tblShare] ON [dbo].[tblShare]([fldsSectorName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tblSharePick] WITH NOCHECK ADD 
	CONSTRAINT [IX_tblSharePick] UNIQUE  NONCLUSTERED 
	(
		[fldsShareName],
		[fldiPortfolioId]
	)  ON [PRIMARY] 
GO

 CREATE  INDEX [IX_tblSharePick_1] ON [dbo].[tblSharePick]([fldsSharePickTypeName]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblUser] ON [dbo].[tblUser]([fldslCountryName]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblUser_1] ON [dbo].[tblUser]([fldiId]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblUser_2] ON [dbo].[tblUser]([fldbNotify]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblUser_3] ON [dbo].[tblUser]([fldbSAActive]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tblUser_4] ON [dbo].[tblUser]([fldbSATest]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tbllMessage] WITH NOCHECK ADD 
	CONSTRAINT [DF_tbllMessage_fldCreateDate] DEFAULT (getdate()) FOR [fldCreateDate]
GO

 CREATE  INDEX [IX_tbllMessage] ON [dbo].[tbllMessage]([fldlMessageTypeId]) ON [PRIMARY]
GO

 CREATE  INDEX [IX_tlkpStockExchange] ON [dbo].[tlkpStockExchange]([fldslCountryName]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[tlkplCountry] WITH NOCHECK ADD 
	CONSTRAINT [IX_tlkplCountry] UNIQUE  NONCLUSTERED 
	(
		[fldsDescription]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[tblFundGame] ADD 
	CONSTRAINT [FK_tblFundGame_tlkpFundGameType] FOREIGN KEY 
	(
		[fldsFundGameTypeName]
	) REFERENCES [dbo].[tlkpFundGameType] (
		[fldsName]
	),
	CONSTRAINT [FK_tblFundGame_tlkpStockExchange] FOREIGN KEY 
	(
		[fldsStockExchangeName]
	) REFERENCES [dbo].[tlkpStockExchange] (
		[fldsName]
	)
GO

ALTER TABLE [dbo].[tblPortfolio] ADD 
	CONSTRAINT [FK_tblPortfolio_tblFundGame] FOREIGN KEY 
	(
		[fldiFundGameId]
	) REFERENCES [dbo].[tblFundGame] (
		[fldiId]
	),
	CONSTRAINT [FK_tblPortfolio_tblUser] FOREIGN KEY 
	(
		[fldiUserId]
	) REFERENCES [dbo].[tblUser] (
		[fldiId]
	),
	CONSTRAINT [FK_tblPortfolio_tlkpPortfolioSelectionType] FOREIGN KEY 
	(
		[fldsPortfolioSelectionTypeName]
	) REFERENCES [dbo].[tlkpPortfolioSelectionType] (
		[fldName]
	),
	CONSTRAINT [FK_tblPortfolio_tlkpRegistrationType] FOREIGN KEY 
	(
		[fldsRegistrationTypeName]
	) REFERENCES [dbo].[tlkpRegistrationType] (
		[fldsName]
	)
GO

ALTER TABLE [dbo].[tblShare] ADD 
	CONSTRAINT [FK_tblShare_tlkpShareSector] FOREIGN KEY 
	(
		[fldsSectorName]
	) REFERENCES [dbo].[tlkpShareSector] (
		[fldsName]
	)
GO

ALTER TABLE [dbo].[tblSharePick] ADD 
	CONSTRAINT [FK_tblSharePick_tblPortfolio] FOREIGN KEY 
	(
		[fldiPortfolioId]
	) REFERENCES [dbo].[tblPortfolio] (
		[fldiId]
	),
	CONSTRAINT [FK_tblSharePick_tblShare] FOREIGN KEY 
	(
		[fldsShareName]
	) REFERENCES [dbo].[tblShare] (
		[fldsName]
	),
	CONSTRAINT [FK_tblSharePick_tlkpSharePickType] FOREIGN KEY 
	(
		[fldsSharePickTypeName]
	) REFERENCES [dbo].[tlkpSharePickType] (
		[fldsName]
	)
GO

ALTER TABLE [dbo].[tblUser] ADD 
	CONSTRAINT [FK_tblUser_tlkpSex] FOREIGN KEY 
	(
		[fldsSexName]
	) REFERENCES [dbo].[tlkpSex] (
		[fldName]
	),
	CONSTRAINT [FK_tblUser_tlkpStockExchange] FOREIGN KEY 
	(
		[fldsPrimaryStockExchangeName]
	) REFERENCES [dbo].[tlkpStockExchange] (
		[fldsName]
	)
GO

ALTER TABLE [dbo].[tbllMessage] ADD 
	CONSTRAINT [FK_tbllMessage_tlkplMessageType] FOREIGN KEY 
	(
		[fldlMessageTypeId]
	) REFERENCES [dbo].[tlkplMessageType] (
		[fldId]
	)
GO

ALTER TABLE [dbo].[tlkpStockExchange] ADD 
	CONSTRAINT [FK_tlkpStockExchange_tlkplCountry] FOREIGN KEY 
	(
		[fldslCountryName]
	) REFERENCES [dbo].[tlkplCountry] (
		[fldsName]
	)
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of all games */
CREATE PROCEDURE spgFundGameGetAll
as
select fldsName, fldsDescription
from tblFundGame
order by fldiDisplayOrder
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of the specified fund\game */
CREATE PROCEDURE spgFundGameGetById
@iId int AS
SELECT     fldsName, fldsFundGameTypeName, flddInitialCashValue
FROM         tblFundGame
where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Selects details of the specified portfolio */
CREATE PROCEDURE spgPortfolioById
@iId int
as
SELECT     fldsPortfolioSelectionTypeName, fldsRegistrationTypeName
FROM         tblPortfolio
where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Selects details of the portfolio for the specified combination of user and fund/game */
CREATE PROCEDURE spgPortfolioByUserFundGame
@iUserId int,
@iFundGameId int
as
SELECT     fldsRegistrationTypeName, fldiId
FROM         tblPortfolio
where fldiUserId = @iUserId and
fldiFundGameId = @iFundGameId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Selects details for the specified portfolio */
CREATE PROCEDURE spgPortfolioGetById
@iId int
as
SELECT     fldsPortfolioSelectionTypeName, fldsRegistrationTypeName
FROM         tblPortfolio
where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of the Portfolios for the specified user and related details,
as displayed in the Portfolio Listing section of the User Account Summary page */
CREATE PROCEDURE spgPortfolioListingByUser
@iUserId int
AS
SELECT     atblPortfolio.fldiId, atblPortfolio.fldiRankingDEV, tblFundGame.fldiFundEntrantsDEV, tblFundGame.fldbDisableStandingDisplay, 
tblFundGame.fldsName, 
                      atblPortfolio.flddPortfolioValueDEV, tblFundGame.fldiId as afldFundGameId
FROM         (SELECT * FROM tblPortfolio where fldiUserId = @iUserId) atblPortfolio 
 RIGHT OUTER JOIN
                      tblFundGame ON atblPortfolio.fldiFundGameId = tblFundGame.fldiId
ORDER BY  tblFundGame.fldiDisplayOrder
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of the Portfolio for the specified fund and user */
CREATE PROCEDURE spgPortfolioSummaryByUserFund
@iUserId int,
@iFundGameId int
as
SELECT     tblPortfolio.fldiId, tblFundGame.fldiFundEntrantsDEV, fldsPortfolioSelectionTypeName, fldiRankingDEV,
	fldbDisableStandingDisplay, flddPortfolioValueDEV, flddInitialCashValue
FROM         tblPortfolio INNER JOIN
                      tblFundGame ON tblPortfolio.fldiFundGameId = tblFundGame.fldiId
where fldiUserId = @iUserId and
tblFundGame.fldiId = @iFundGameId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spgPrimaryStockExchangeByUser
/* Returns details of the fund associated with the specified user's primary exchange */
@iUserId int
as
SELECT     tblFundGame.fldsName, tblFundGame.fldiId
FROM         tblUser INNER JOIN
                      tlkpStockExchange ON tblUser.fldsPrimaryStockExchangeName = tlkpStockExchange.fldsName INNER JOIN
                      tblFundGame ON tlkpStockExchange.fldsName = tblFundGame.fldsStockExchangeName INNER JOIN
                      tlkpFundGameType ON tblFundGame.fldsFundGameTypeName = tlkpFundGameType.fldsName
WHERE     (tlkpFundGameType.fldsName = 'Fund') and tblUser.fldiId = @iUserId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of all share picks and related data for the specified portfolio, ordered by the share pick line */
CREATE PROCEDURE spgSharePicksByPortfolio
@iPortfolioId int
as
SELECT     tblSharePick.fldsShareName, tblShare.fldsDescription, tblSharePick.flddQuantity, tblSharePick.flddInitialPriceDEV, tblShare.flddCurrentPriceDEV, 
                      tblSharePick.flddCommissionDEV, tblSharePick.fldsSharePickTypeName, tblSharePick.flddCashSurplusDEV
FROM         tblSharePick INNER JOIN
                      tblShare ON tblSharePick.fldsShareName = tblShare.fldsName
where fldiPortfolioId = @iPortfolioId
order by fldiLine
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Return details of all stock exchanges */
CREATE PROCEDURE spgStockExchangeGetAll
as
select fldsName, fldsDescription from tlkpStockExchange
order by fldsName
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Selects all details for the specified user */
CREATE PROCEDURE spgUserGetById
@iId int
as
select * from tblUser
where fldiId = @iId

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Returns the list of users for the All Users Performance Report */
CREATE PROCEDURE spgUsersPerformanceReport
as
select fldiId, fldsTitle, fldsFirstName, fldsLastName
from tblUser
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Returns id and password of the user with the specified email, used to login */
CREATE PROCEDURE spglaLogin
@sLogin nvarchar(50)
as
select fldiId, fldsPassword
from tblUser
where fldsEMail = @sLogin
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Returns details of the user with the specified id */
CREATE PROCEDURE spglaLoginDetails
@iId integer
as
select fldsTitle, fldsFirstName, fldsLastName
from tblUser
where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spiESignalDownloadHistory
@sESignalStockName nvarchar(8),
@dOpen float,
@dHigh float,
@dLow float,
@dClose float,
@dVolume float,
@dtTime datetime,
@btbfFlags bit,
@dOI float,
@dTickBid float,
@dTickAsk float,
@dTickTrade float
as
insert into tblESignalDownloadHistory
(
fldESignalStockName,
flddOpen,
flddHigh,
flddLow,
flddClose,
flddVolume,
flddtTime,
fldbtbfFlags,
flddOI,
flddTickBid,
flddTickAsk,
flddTickTrade
)
values (
@sESignalStockName,
@dOpen,
@dHigh,
@dLow,
@dClose,
@dVolume,
@dtTime,
@btbfFlags,
@dOI,
@dTickBid,
@dTickAsk,
@dTickTrade
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spiESignalDownloadHistory2
@sESignalStockName nvarchar(6),
@dClose float,
@dtTime datetime
as
insert into tblESignalDownloadHistory2
(
fldESignalStockName,
flddClose,
flddtTime
)
values (
@sESignalStockName,
@dClose,
@dtTime
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spiESignalDownloadQuote

@sESignalStockName nvarchar(6),
@dAsk float,
@dBid float,
@dLast float,
@ilAskSize int,
@ilBidSize int,
@ilLastSize int
as
insert into tblESignalDownloadQuote
(
fldsESignalStockName,
flddAsk,
flddBid,
flddLast,
fldilAskSize,
fldilBidSize,
fldilLastSize
)
values (
@sESignalStockName,
@dAsk,
@dBid,
@dLast,
@ilAskSize,
@ilBidSize,
@ilLastSize
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spiESignalDownloadTimeSales
@sESignalStockName nvarchar(6),
@dPrice float,
@dtTime datetime,
@lFlags int,
@lSize int,
@sExchange nvarchar(100)

as
insert into tblESignalDownloadTimeSales
(
fldESignalStockName,
flddPrice,
flddtTime,
fldlFlags,
fldlSize,
fldsExchange
)
values (
@sESignalStockName,
@dPrice,
@dtTime,
@lFlags,
@lSize,
@sExchange
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Inserts a record into the Portfolio table */
CREATE PROCEDURE spiPortfolio
@iUserId int,
@iId int,
@iFundGameId int,
@sPortfolioSelectionTypeName nvarchar(20),
@sRegistrationTypeName nvarchar(20),
@bPay int
as
insert into tblPortfolio (
fldiUserId,
fldiId,
fldiFundGameId,
fldsPortfolioSelectionTypeName,
fldsRegistrationTypeName,
fldbPay)
values (
@iUserId,
@iId,
@iFundGameId,
@sPortfolioSelectionTypeName,
@sRegistrationTypeName,
@bPay
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

CREATE PROCEDURE spiUser
@iId int,
@sTitle nvarchar(3),
@sSexName nvarchar(1),
@sFirstName nvarchar(50),
@sLastName nvarchar(50),
@sAddress nvarchar(200),
@sPostCode nvarchar(8),
@slCountryName nvarchar(3),
@sTel nvarchar(20),
@sEmail nvarchar(50),
@sPassword nvarchar(20),
@sPrimaryStockExchangeName nvarchar(20),
@bNotify int,
@bSAActive int,
@bSATest int,
@sSAWhiteLabelVersion nvarchar(50)

as
insert into tblUser(fldiId, fldsTitle, fldsSexName, fldsFirstName, fldsLastName, fldsAddress, fldsPostCode, fldslCountryName,
fldsTel, fldsEmail, fldsPassword, fldsPrimaryStockExchangeName, fldbNotify, fldbSAActive, fldbSATest, fldsSAWhiteLabelVersion)
values (
@iId,
@sTitle,
@sSexName,
@sFirstName,
@sLastName,
@sAddress,
@sPostCode,
@slCountryName,
@sTel,
@sEmail,
@sPassword,
@sPrimaryStockExchangeName,
@bNotify,
@bSAActive,
@bSATest,
@sSAWhiteLabelVersion
)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Selects the id in tbllCounter for the specified reference */
CREATE PROCEDURE splCounterIdByRef
@sRef nvarchar(255)
as select fldId
from tbllCounter
where fldRef = @sRef
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Return details of all countries */
CREATE PROCEDURE splgCountryGetAll
as
select fldsName, fldsDescription
from tlkplCountry
order by fldsName
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Creates a record in tbllCounter with the specified reference */
CREATE PROCEDURE spliCounter
@sRef nvarchar(255)
as insert into tbllCounter(fldId, fldRef)
values (1, @sRef)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Inserts a record into tbllMessage */
/* Geoff Olding 9/9/2 */
CREATE PROCEDURE spliMessage
@sUser nvarchar(255),
@sErrDEscription nvarchar(4000),
@sContext nvarchar(4000),
@sStack nvarchar(4000),
@ilMessageTypeId integer,
@sBrowserDetails ntext,
@sTransactionMessage nvarchar(100)
as
insert into tbllMessage(
	fldUser, 
	fldErrDescription,
	fldContext,
	fldStack,
	fldlMessageTypeId,
	fldBrowserDetails,
	fldTransactionMessage)
values (
	@sUser,
	@sErrDescription,
	@sContext,
	@sStack,
	@ilMessageTypeId,
	@sBrowserDetails,
	@sTransactionMessage)
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO


/* Updates the record in tbllCounter with the specified reference to the specified value */

CREATE PROCEDURE spluCounterByRef
@sRef nvarchar(255),
@iId int
as
update tbllCounter
set fldId = @iId
where fldRef = @sRef
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS OFF 
GO

/* Updates a record into the Portfolio table */
CREATE PROCEDURE spuPortfolio
@iId int,
@sPortfolioSelectionTypeName nvarchar(20),
@sRegistrationTypeName nvarchar(20),
@bPay int
as
update tblPortfolio
set fldsPortfolioSelectionTypeName = @sPortfolioSelectionTypeName,
fldsRegistrationTypeName = @sRegistrationTypeName,
fldbPay = @bPay
where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS OFF 
GO

/* Updates the specified user record */
CREATE PROCEDURE spuUser
@iId int,
@sTitle nvarchar(3),
@sSexName nvarchar(1),
@sFirstName nvarchar(50),
@sLastName nvarchar(50),
@sAddress nvarchar(200),
@sPostCode nvarchar(8),
@slCountryName nvarchar(3),
@sTel nvarchar(20),
@sEmail nvarchar(50),
@sPassword nvarchar(20),
@sPrimaryStockExchangeName nvarchar(20),
@bNotify int,
@bSAActive int,
@bSATest int,
@sSAWhiteLabelVersion nvarchar(50)

as

update tblUser
set fldsTitle = @sTitle,
fldsSexName = @sSexName,
fldsFirstName = @sFirstName,
fldsLastName = @sLastName,
fldsAddress = @sAddress,
fldsPostCode = @sPostCode,
fldslCountryName = @slCountryName,
fldsTel = @sTel,
fldsEmail = @sEmail,
fldsPassword = @sPassword,
fldsPrimaryStockExchangeName = @sPrimaryStockExchangeName,
fldbNotify = @bNotify,
fldbSAActive = @bSAActive,
fldbSATest = @bSATest,
fldsSAWhiteLabelVersion = @sSAWhiteLabelVersion

where fldiId = @iId
GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

